searchNodes=[{"doc":"XML to Map conversion. SAXMap uses a SAX parser (built on top of Saxy ) to transfer an XML string or file stream into a Map containing a collection of pairs where the key is the element name and the value is its content, and it is a optional to process element attribute into the result.","ref":"SAXMap.html","title":"SAXMap","type":"module"},{"doc":"Use Saxy.parse_stream/4 with a custom SAX parse handler to extract a Map containing a collection of pairs where the key is the element name and the value is its content, there can optionally append the key-value pair from the attribute of element. Options Please see from_string/2","ref":"SAXMap.html#from_stream/2","title":"SAXMap.from_stream/2","type":"function"},{"doc":"Use Saxy.parse_string/4 with a custom SAX parse handler to extract a Map containing a collection of pairs where the key is the element name and the value is its content, there can optionally append the key-value pair from the attribute of element. Example Here is an example: iex&gt; xml = &quot;&quot;&quot; ...&gt; &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; ...&gt; &lt;thread&gt; ...&gt; &lt;title&gt;Hello&lt;/title&gt; ...&gt; &lt;items&gt; ...&gt; &lt;item&gt;item1&lt;/item&gt; ...&gt; &lt;item&gt;item2&lt;/item&gt; ...&gt; &lt;/items&gt; ...&gt; &lt;/thread&gt; ...&gt; &quot;&quot;&quot; iex&gt; SAXMap . from_string ( xml ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;item&quot; =&gt; [ &quot;item1&quot; , &quot;item2&quot; ] } , &quot;title&quot; =&gt; &quot;Hello&quot; } } } Options :ignore_attribute , whether to ignore the attributes of elements in the final map, by default is true so there will not see any attributes in the result; when set this option as false , it equals {false, &quot;&quot;} , in this case, there with append the attributes of all elements by the processing order, and put the attributes key-value pair into the peer child elements, and automatically naming child elements with &quot;content&quot;, we can also set this option as {false, &quot;@&quot;} or {false, &quot;-&quot;} , any proper naming prefix you perfer should be fine to process. xml = &quot;&quot;&quot; &lt;thread version=&quot;1&quot;&gt; &lt;title color=&quot;red&quot; font=&quot;16&quot;&gt;Hello&lt;/title&gt; &lt;items size=&quot;3&quot;&gt; &lt;item font=&quot;12&quot;&gt;item1&lt;/item&gt; &lt;item font=&quot;12&quot;&gt;item2&lt;/item&gt; &lt;item font=&quot;12&quot;&gt;item3&lt;/item&gt; &lt;/items&gt; &lt;/thread&gt; &quot;&quot;&quot; # set ignore_attribute: false SAXMap . from_string ( xml , ignore_attribute : false ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;content&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;content&quot; =&gt; %{ &quot;item&quot; =&gt; [ %{ &quot;content&quot; =&gt; &quot;item1&quot; , &quot;font&quot; =&gt; &quot;12&quot; } , %{ &quot;content&quot; =&gt; &quot;item2&quot; , &quot;font&quot; =&gt; &quot;12&quot; } , %{ &quot;content&quot; =&gt; &quot;item3&quot; , &quot;font&quot; =&gt; &quot;12&quot; } ] } , &quot;size&quot; =&gt; &quot;3&quot; } , &quot;title&quot; =&gt; %{ &quot;color&quot; =&gt; &quot;red&quot; , &quot;content&quot; =&gt; &quot;Hello&quot; , &quot;font&quot; =&gt; &quot;16&quot; } } , &quot;version&quot; =&gt; &quot;1&quot; } } } # set ignore_attribute: {false, &quot;@&quot;} SAXMap . from_string ( xml , ignore_attribute : { false , &quot;@&quot; } ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;@version&quot; =&gt; &quot;1&quot; , &quot;content&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;@size&quot; =&gt; &quot;3&quot; , &quot;content&quot; =&gt; %{ &quot;item&quot; =&gt; [ %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item1&quot; } , %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item2&quot; } , %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item3&quot; } ] } } , &quot;title&quot; =&gt; %{ &quot;@color&quot; =&gt; &quot;red&quot; , &quot;@font&quot; =&gt; &quot;16&quot; , &quot;content&quot; =&gt; &quot;Hello&quot; } } } } } Please notice that the comments of XML are ignored.","ref":"SAXMap.html#from_string/2","title":"SAXMap.from_string/2","type":"function"},{"doc":"Converts an XML String or an XML file stream to a Map. Benefit from Saxy 's SAX mode, this library has a good conversion efficiency.","ref":"readme.html","title":"SAXMap","type":"extras"},{"doc":"def deps do [ { :sax_map , &quot;~&gt; 1.2&quot; } ] end","ref":"readme.html#installation","title":"SAXMap - Installation","type":"extras"},{"doc":"iex(1)&gt; xml = &quot;&quot;&quot; ...(1)&gt; &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; ...(1)&gt; &lt;thread&gt; ...(1)&gt; &lt;title&gt;Hello&lt;/title&gt; ...(1)&gt; &lt;items&gt; ...(1)&gt; &lt;item&gt;item1&lt;/item&gt; ...(1)&gt; &lt;item&gt;item2&lt;/item&gt; ...(1)&gt; &lt;/items&gt; ...(1)&gt; &lt;/thread&gt; ...(1)&gt; &quot;&quot;&quot; iex(2)&gt; SAXMap . from_string ( xml ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;item&quot; =&gt; [ &quot;item1&quot; , &quot;item2&quot; ] } , &quot;title&quot; =&gt; &quot;Hello&quot; } } } By default SAXMap.from_string will ignore all attributes of elements in the result, if you want to merge the attributes as the child elements, please use ignore_attribute option to achieve this: xml = &quot;&quot;&quot; &lt;thread version=&quot;1&quot;&gt; &lt;title color=&quot;red&quot; font=&quot;16&quot;&gt;Hello&lt;/title&gt; &lt;items size=&quot;3&quot;&gt; &lt;item font=&quot;12&quot;&gt;item1&lt;/item&gt; &lt;item font=&quot;12&quot;&gt;item2&lt;/item&gt; &lt;item font=&quot;12&quot;&gt;item3&lt;/item&gt; &lt;/items&gt; &lt;/thread&gt; &quot;&quot;&quot; SAXMap . from_string ( xml , ignore_attribute : false ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;content&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;content&quot; =&gt; %{ &quot;item&quot; =&gt; [ %{ &quot;content&quot; =&gt; &quot;item1&quot; , &quot;font&quot; =&gt; &quot;12&quot; } , %{ &quot;content&quot; =&gt; &quot;item2&quot; , &quot;font&quot; =&gt; &quot;12&quot; } , %{ &quot;content&quot; =&gt; &quot;item3&quot; , &quot;font&quot; =&gt; &quot;12&quot; } ] } , &quot;size&quot; =&gt; &quot;3&quot; } , &quot;title&quot; =&gt; %{ &quot;color&quot; =&gt; &quot;red&quot; , &quot;content&quot; =&gt; &quot;Hello&quot; , &quot;font&quot; =&gt; &quot;16&quot; } } , &quot;version&quot; =&gt; &quot;1&quot; } } } SAXMap . from_string ( xml , ignore_attribute : { false , &quot;@&quot; } ) { :ok , %{ &quot;thread&quot; =&gt; %{ &quot;@version&quot; =&gt; &quot;1&quot; , &quot;content&quot; =&gt; %{ &quot;items&quot; =&gt; %{ &quot;@size&quot; =&gt; &quot;3&quot; , &quot;content&quot; =&gt; %{ &quot;item&quot; =&gt; [ %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item1&quot; } , %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item2&quot; } , %{ &quot;@font&quot; =&gt; &quot;12&quot; , &quot;content&quot; =&gt; &quot;item3&quot; } ] } } , &quot;title&quot; =&gt; %{ &quot;@color&quot; =&gt; &quot;red&quot; , &quot;@font&quot; =&gt; &quot;16&quot; , &quot;content&quot; =&gt; &quot;Hello&quot; } } } } } Notice : The ignore_attribute: false equals ignore_attribute: {false, &quot;&quot;} , in this case, the child elements will be automatically naming with &quot;content&quot; as the key of the key-value pair to distinct this key-value pair is from content or attribute.","ref":"readme.html#example","title":"SAXMap - Example","type":"extras"},{"doc":"Only for your reference, all credit goes to Saxy , the details of benchmark can be found in the bench directory of the repository. Run: mix run xml_to_map.exs Output: Operating System: macOS CPU Information: Intel(R) Core(TM) i9-9880H CPU @ 2.30GHz Number of Available Cores: 16 Available memory: 32 GB Elixir 1.12.2 Erlang 24.0.4 Benchmark suite executing with the following configuration: warmup: 2 s time: 10 s memory time: 2 s parallel: 1 inputs: none specified Estimated total run time: 42 s Benchmarking SAXMap.from_string ignore attribute... Benchmarking SAXMap.from_string with attribute... Benchmarking XmlToMap.naive_map... Name ips average deviation median 99th % SAXMap.from_string ignore attribute 105.03 K 9.52 μs ±129.42% 9 μs 33 μs SAXMap.from_string with attribute 96.74 K 10.34 μs ±110.08% 9 μs 35 μs XmlToMap.naive_map 26.31 K 38.01 μs ±46.21% 33 μs 105 μs Comparison: SAXMap.from_string ignore attribute 105.03 K SAXMap.from_string with attribute 96.74 K - 1.09x slower +0.82 μs XmlToMap.naive_map 26.31 K - 3.99x slower +28.49 μs Memory usage statistics: Name Memory usage SAXMap.from_string ignore attribute 14.61 KB SAXMap.from_string with attribute 16.69 KB - 1.14x memory usage +2.08 KB XmlToMap.naive_map 40.90 KB - 2.80x memory usage +26.29 KB **All measurements for memory usage were the same**","ref":"readme.html#benchmark","title":"SAXMap - Benchmark","type":"extras"}]